using FarPoint.Win.Spread;
using FarPoint.Win.Spread.CellType;

namespace DecimalPointNumberCell
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }


        private void Form1_Load(object sender, EventArgs e)
        {
            NumberCellType numCell = new NumberCellType2(fpSpread1, "0.00####");
            numCell.DecimalPlaces = 6;
            fpSpread1.ActiveSheet.AsWorksheet().Cells["A1:A10"].CellType = numCell;
        }
    }

    public class NumberCellType2 : NumberCellType
    {
        private FpSpread _spread;

        public NumberCellType2(FpSpread spread, string formatCode)
        {
            _spread = spread;
            NumberFormat = formatCode;
        }

        public string NumberFormat { get; set; }

        public override string Format(object obj)
        {
            GrapeCity.Spreadsheet.NumberFormat numFmt = new GrapeCity.Spreadsheet.NumberFormat(NumberFormat);
            var workbook = _spread.AsWorkbook();
            var formatter = numFmt.GetFormatter(workbook, workbook.WorkbookSet.Culture);
            var result = formatter.Format(obj);
            if (result.Success)
            {
                return result.Text;
            }
            return base.Format(obj);
        }

        public override void PaintCell(Graphics g, Rectangle r, FarPoint.Win.Spread.Appearance appearance, object value, bool isSelected, bool isLocked, float zoomFactor)
        {
            string text = Format(value);
            base.PaintCell(g, r, appearance, text, isSelected, isLocked, zoomFactor);
        }
    }
}